# -*- coding: utf-8 -*-
"""Iris_machine.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1VFtuWjpqwxRneIQIMsO95HZdtagz6yx7

#load iris
"""

from sklearn import datasets
iris = datasets.load_iris()
print(list(iris))
print("\n* Descriptions: ", iris.DESCR)
print("\n* Features: ", iris.feature_names)
print("\n* Data: ", iris.data)
print("\n* Target: ", iris.target,iris.target_names)

"""# create dataframe from iris

"""

import pandas as pd
df =pd.DataFrame(data=iris.data, columns=iris.feature_names)
df['target'] = iris.target
df # display  dataframe

"""# visualization of dataframe

"""

import matplotlib.pyplot as plt
fig, ax = plt.subplots(1, 4, figsize = (12, 3))
for i in range (4):
  column = df.columns[i]
  ax[i].scatter(df[column], df['target'])
  ax[i].set_xlabel (column)
  ax[i].set_ylabel('target')
  plt.tight_layout
  plt.show()

"""#create dataset from dataframe"""

X=df.loc[:, 'sepal length (cm)':'petal width (cm)']
y=df.loc[:, 'target']
print('\n(X_data, y_data):\n', X, '\n', y)
#split on dataset into training (80%) and testing (20%)
from sklearn import model_selection
X_train, X_test, y_train, y_test = model_selection.train_test_split(X, y, test_size = 0.2, random_state = 1234)
print ('\n(X_train, y_train):\n', X_train, '\n', y_train)
print ('\n(X_test, y_test):\n', X_test, "\n", y_test)

"""#training"""

#training
from sklearn import neighbors
model = neighbors.KNeighborsClassifier (n_neighbors = 3, p =2) # p =1: Manhattan, p = 2: Euclidean
model.fit (X_train, y_train)
#evaluation
from sklearn import metrics
y_test_hat = model.predict(X_test)
print (metrics.accuracy_score (y_test, y_test_hat))
print (metrics.f1_score(y_test, y_test_hat, average = 'macro'))
#visualization of confusion matrix
import matplotlib.pyplot as plt
metrics.ConfusionMatrixDisplay.from_predictions(y_test, y_test_hat, labels = [0,1,2], display_labels = iris.target_names, colorbar = False)
plt.xlabel ('Predicted')
plt.ylabel ('Actual')
plt.title ('Testing set')
plt.show()

"""#Gausian NB

"""

# training
from sklearn import naive_bayes
model = naive_bayes.GaussianNB()
model.fit(X_train, y_train)

#evaluation
from sklearn import metrics
y_test_hat = model.predict(X_test)
print (metrics.accuracy_score(y_test, y_test_hat))
print(metrics.f1_score(y_test, y_test_hat, average = 'macro'))
#visualization of confusion matrix
import matplotlib.pyplot as plt
metrics.ConfusionMatrixDisplay.from_predictions(y_test, y_test_hat, labels= [0,1,2], display_labels=iris.target_names, colorbar = False)

plt.xlabel ('Predicted')
plt.ylabel ('Actual')
plt.title ('Testing set')
plt.show()

"""#Decision tree"""

#trainning
from sklearn import tree
model = tree.DecisionTreeClassifier(random_state=0)
model.fit(X_train, y_train)
#evaluation
from sklearn import metrics
y_test_hat = model.predict(X_test)
print(metrics.accuracy_score(y_test, y_test_hat))
print (metrics.f1_score(y_test, y_test_hat, average='macro'))
#visualization of confusion matrix
import matplotlib.pyplot as plt
metrics.ConfusionMatrixDisplay.from_predictions(y_test, y_test_hat, labels = [0, 1, 2], display_labels
                                                =iris.target_names, colorbar=False)
plt.xlabel ("Predicted")
plt.ylabel ("Actual")
plt.title ("Testing set")
plt.show()

"""Neural network


"""

# convert 1-dimensional class arrays to 3-dimensional class matrics
from keras import utils
Y_train = utils.to_categorical(y_train, 3)
Y_test = utils.to_categorical(y_test, 3)
# training with epochs = 1000
from keras import models, layers, losses, optimizers
model = models.Sequential ([
    layers.Dense(units=4, activation='relu', name='layer1'),
    layers.Dense(units=3, activation='softmax', name='layer2')
    ])

model.compile(
    loss=losses.CategoricalCrossentropy(),
    optimizer=optimizers.Adam(learning_rate=0.01)
)



model.fit(X_train, Y_train, epochs=1000, verbose=0)
#evaluation
from sklearn import metrics
Y_test_hat = (model.predict(X_test) >= 0.5).astype(int)
print(metrics.accuracy_score(Y_test, Y_test_hat))
print(metrics.f1_score(Y_test, Y_test_hat, average='macro'))
import matplotlib.pyplot as plt
metrics.ConfusionMatrixDisplay.from_predictions(Y_test.argmax(axis=1), Y_test_hat.argmax(axis=1), labels = [0, 1, 2], display_labels
                                                =iris.target_names, colorbar=False)
plt.xlabel ("Predicted")
plt.ylabel ("Actual")
plt.title ("Testing set")
plt.show()